//***************************************************************************

// Copyright (C) 2009 Realmac Software Ltd
//
// These coded instructions, statements, and computer programs contain
// unpublished proprietary information of Realmac Software Ltd
// and are protected by copyright law. They may not be disclosed
// to third parties or copied or duplicated in any form, in whole or
// in part, without the prior written consent of Realmac Software Ltd.

// Created by Danny Greg on 24/08/2010. 

//***************************************************************************

#import <Cocoa/Cocoa.h>

//***************************************************************************

@class RMRegistrationController;
@class RMRegistrationOrderCompleteViewController;

//***************************************************************************

extern NSString *const RMRegistrationViewControllerShouldShowInApplicationStoreViewControllerNotificationName;
extern NSString *const RMRegistrationViewControllerShouldCloseNotificationName;

@interface RMRegistrationViewController : NSViewController {
	RMRegistrationController *_registrationController;
	
	NSString *_serialNumber;
	NSString *_errorString;
	
	RMRegistrationOrderCompleteViewController *_orderCompleteViewController;
}

// Note: must be set before loading the view, otherwise an exception is thrown
@property (retain) RMRegistrationController *registrationController;

// Note: for binding to
@property (nonatomic, copy) NSString *serialNumber;
@property (nonatomic, copy) NSString *errorString;

- (IBAction)showInApplicationStore:(id)sender;
- (IBAction)visitOnlineStore:(id)sender;

- (IBAction)registerApplication:(id)sender;

- (IBAction)hideRegistrationView:(id)sender;

@end
