//***************************************************************************

// Copyright (C) 2008-2010 Realmac Software Ltd
//
// These coded instructions, statements, and computer programs contain
// unpublished proprietary information of Realmac Software Ltd
// and are protected by copyright law. They may not be disclosed
// to third parties or copied or duplicated in any form, in whole or
// in part, without the prior written consent of Realmac Software Ltd.

//***************************************************************************

#import <Cocoa/Cocoa.h>

//***************************************************************************

#define kWindowLayerName	@"WindowLayerName"		// NSString - layer name (most likely window name if available)
#define kWindowLayerOrigin	@"WindowLayerOrigin"	// NSValue (NSPoint) - layer (window!) origin (not including shadow)
#define kWindowLayerSize	@"WindowLayerSize"		// NSValue (NSSize) - layer (image) bounds (not including shadow)
#define kWindowLayerBounds	@"WindowLayerBounds"	// NSValue (NSRect) - window bounds (not including shadow)
#define kWindowLayerImage	@"WindowLayerImage"		// NSBitmapImageRep - layer image (not including shadow)
#define kWindowShadowLayerImage	@"WindowShadowLayerImage"		// NSBitmapImageRep - shadow layer image
#define kWindowLayerOwner	@"WindowLayerOwner"		// NSString - The name of the app that owns the window
#define kWindowLevel		@"WindowLevel"			// NSNumber - Window level 
#define kCursorHotSpot      @"CursorHotSpot"			// NSPoint as string indicating the hotspot position for the snapped cursor.
// Entries specific to screen grabs
#define kScreenLayerID		@"ScreenLayerID"
#define kScreenWindowArray	@"ScreenWindowArray"
#define kScreenLayerFrame	@"ScreenlayerFrame"
#define kDockPosition       @"DockPosition"
#define kDockPinning        @"DockPinning"


@class PTHotKey;

@interface RMScreenSnapper : NSObject {
	NSPanel				*highlightPanel;
	id					delegate;
	BOOL				isSnapping;
	BOOL				includeShadows;
	BOOL				includeCursor;
	BOOL				playSounds;
}

+ (RMScreenSnapper *)snapper;
+ (void)playSnapSound;
- (void)flashScreen;

- (void)snapWindow;
- (void)snapRegion;
- (void)snapDesktop;

@property (retain, readwrite) id delegate;
@property (readwrite) BOOL isSnapping;
@property (readwrite) BOOL includeShadows;
@property (readwrite) BOOL includeCursor;
@property (assign) BOOL playSounds;

@end

@interface NSObject (RMSnapKitDelegate)
- (BOOL)screenSnapperShouldSnap:(RMScreenSnapper *)sender;
- (void)screenSnapperDidBeginSnap:(RMScreenSnapper *)sender;
- (void)screenSnapperDidSnap:(RMScreenSnapper *)sender withImages:(NSArray *)images;
- (void)screenSnapper:(RMScreenSnapper *)sender didFailWithError:(NSError *)error; // TODO: Failure? what's that?
- (void)userCancelledSnap:(RMScreenSnapper *)sender; // TODO: still no way to cancel :P
@end
